Subject: Re: bug#70345: [PATCH] 29.1.50; csharp-ts-mode indentation of if statements with single-statement body

From: Yuan Fu <[email-masked]>
Date: Sun, 14 Apr 2024 16:02:50 -0700

Eli Zaretskii <[email-masked]> writes:

>> From: Jacob Leeming <[email-masked]>
>> Date: Thu, 11 Apr 2024 21:32:02 +0100
>> 
>> Hi all,
>> 
>> >From emacs -Q:
>> 
>> Evaluate this elisp to set up treesitter for csharp:
>> 
>> (setq treesit-language-source-alist '((c-sharp
>> "https://github.com/tree-sitter/tree-sitter-c-sharp" "master" "src"))
>>       treesit-load-name-override-list '((c-sharp
>> "libtree-sitter-csharp" "tree_sitter_c_sharp"))
>>       major-mode-remap-alist '((csharp-mode . csharp-ts-mode)))
>> 
>> Insert the following text into a csharp-ts-mode buffer:
>> 
>> if (true)
>> var x = 2;
>> 
>> Try to indent the variable declaration of the function with
>> indent-for-tab-command. Nothing will happen. I'd expect to see this:
>> 
>> if (true)
>>     var x = 2;
>> 
>> This issue can be fixed with the following patch:
>> 
>> diff --git a/lisp/progmodes/csharp-mode.el b/lisp/progmodes/csharp-mode.el
>> index 53c52e6..1a7d535 100644
>> --- a/lisp/progmodes/csharp-mode.el
>> +++ b/lisp/progmodes/csharp-mode.el
>> @@ -678,7 +678,8 @@ csharp-ts-mode--indent-rules
>>       ((parent-is "binary_expression") parent 0)
>>       ((parent-is "block") parent-bol csharp-ts-mode-indent-offset)
>>       ((parent-is "local_function_statement") parent-bol 0)
>> -     ((parent-is "if_statement") parent-bol 0)
>> +     ((match "block" "if_statement") parent-bol 0)
>> +     ((parent-is "if_statement") parent-bol csharp-ts-mode-indent-offset)
>>       ((parent-is "for_statement") parent-bol 0)
>>       ((parent-is "for_each_statement") parent-bol 0)
>>       ((parent-is "while_statement") parent-bol 0)
>
> Theo and Yuan, any comments?

If Theo is too busy I can take a look, but I don’t really know
csharp-ts-mode too well.

Yuan